--- old/usr/src/lib/libzfs/common/libzfs_sendrecv.c	2015-12-29 17:17:29.552598056 -0500
+++ new/usr/src/lib/libzfs/common/libzfs_sendrecv.c	2015-12-29 17:17:29.559370667 -0500
@@ -25,6 +25,7 @@
  * Copyright (c) 2012, Joyent, Inc. All rights reserved.
  * Copyright (c) 2013 Steven Hartland. All rights reserved.
  * Copyright 2015, OmniTI Computer Consulting, Inc. All rights reserved.
+ * Copyright 2015 RackTop Systems.
  */
 
 #include <assert.h>
@@ -814,6 +815,7 @@
 	boolean_t seenfrom, seento, replicate, doall, fromorigin;
 	boolean_t verbose, dryrun, parsable, progress, embed_data, std_out;
 	boolean_t large_block;
+	boolean_t skip_free;
 	int outfd;
 	boolean_t err;
 	nvlist_t *fss;
@@ -1184,6 +1186,8 @@
 			flags |= LZC_SEND_FLAG_LARGE_BLOCK;
 		if (sdd->embed_data)
 			flags |= LZC_SEND_FLAG_EMBED_DATA;
+		if (sdd->skip_free)
+			flags |= LZC_SEND_FLAG_SKIP_FREE;
 
 		err = dump_ioctl(zhp, sdd->prevsnap, sdd->prevsnap_obj,
 		    fromorigin, sdd->outfd, flags, sdd->debugnv);
@@ -1750,6 +1754,7 @@
 	sdd.progress = flags->progress;
 	sdd.dryrun = flags->dryrun;
 	sdd.large_block = flags->largeblock;
+	sdd.skip_free = flags->skip_free;
 	sdd.embed_data = flags->embed_data;
 	sdd.filter_cb = filter_func;
 	sdd.filter_cb_arg = cb_arg;
